{
########################################
#                                      # 
#  Tool for creating huge empty files  #
#                                      #
#  Vitaly Checkryzhev, 2004            #
#          E-Mail: virty1k@mail.ru     #
#                                      #
########################################
}

program mkbigfile;

{$APPTYPE CONSOLE}

uses
 Windows, SysUtils;

var
 F        : File;
 FileName : String;
 Current,
 Written,
 FSize    : Integer;
 P        : PChar;

const
 BlockSize = 1024 * 1024;

procedure Usage; 
begin
  Writeln ('Usage:');
  Writeln (' mkbigfile.exe filename size');
  Writeln ('Size in megabytes');
  Writeln ('');
  Writeln ('Ex: mkbigfile myfile 1024');
  Writeln ('Will create 1Gb file with name ''myfile''');
end;

begin
 if ParamStr(2) = '' then
 begin
  Usage;
  Halt (1);
 end;

 FileName := ParamStr(1);
 FSize := StrToIntDef(ParamStr(2), 0);

 if FSize <= 0 then
 begin
  Usage;
  Halt (2);
 end;

 GetMem(P, BlockSize);
 if P = nil then
 begin
  Usage;
  Halt (3);
 end;

 FillChar (P^, BlockSize, 0);

 {$I-}
 AssignFile (F, FileName);
 Rewrite (F, 1);
 if IOResult <> 0 then
  begin
   Writeln ('Error creating file!');
   Halt (4);
  end;

 for Current := 1 to FSize do
  begin
   BlockWrite (F, P^, BlockSize, Written);
   if BlockSize <> Written then
    begin
     Writeln ('Exceeding free disk space');
     Halt (5);
    end;
   if Current mod 10 = 0 then
    Write ('.'); 
  end;

 Writeln (''); 
 Writeln ('File was successfully created.'); 

 CloseFile (F);
 FreeMem (P);
end.
